<!---
BEFORE YOU SUBMIT please read the following:

Please search open/closed issues before submitting since someone might have asked the same thing before!

If you have a support request or question please submit them to one of this resources:

* Stack Overflow: http://stackoverflow.com/questions/tagged/request+node.js using the tags `node.js` & `request`
* Gitter community: https://gitter.im/request/request?utm_source=newissue
* Also have a look at the Readme for more information on how to get support:
  https://github.com/request/request/blob/master/README.md

Issues on GitHub are only related to problems of request itself and we cannot answer
support questions here.
-->

### Summary
<!--- Provide a general summary of the issue in the title above -->

### Simplest Example to Reproduce
<!--- If describing a bug, tell us what request options we can use to reproduce the same bug/behavior -->

```js
request({
  method: 'GET',
  url: 'http://example.com', // a public URL that we can hit to reproduce, if possible
  more: { 'options': 'here' }
},
```

### Expected Behavior
<!--- If you're describing a bug, tell us what should happen -->
<!--- If you're suggesting a change/improvement, tell us how it should work -->
<!--- If request is handling requests/responses incorrectly, please include a link to the spec or documentation that supports that your expected behavior is correct. -->

### Current Behavior
<!--- If describing a bug, tell us what happens instead of the expected behavior -->
<!--- If suggesting a change/improvement, explain the difference from current behavior -->

### Possible Solution
<!--- Not obligatory, but suggest a fix/reason for the bug, -->
<!--- or ideas how to implement the addition or change -->

### Context
<!--- How has this issue affected you? What are you trying to accomplish? -->
<!--- Providing context helps us come up with a solution that is most useful in the real world -->

### Your Environment
<!--- Include as many relevant details about the environment you experienced the bug in -->

| software         | version
| ---------------- | -------
| request          |
| node             |
| npm              |
| Operating System |
